# Buttercup compiler, version 0.5

This program is free software. You may redistribute it under the terms of the GNU General Public License version 3 or later. See `license.txt` for details.

Included in this release:

* Lexical analysis
* Syntactic analysis
* AST construction
* Semantic analysis
* WAT & WASM code generation

## Requirements

You need Node.js 12 or newer. Go to the [Node.js website](https://nodejs.org/en/download/). If you need to install it.

To check that you have the correct version of Node.js, at the terminal type:

    node -v

The output should show that you are using version 12 or higher:

    v14.15.0

## How to Build

To install the required Node.js modules and build the C# code, at the terminal type:

    make

## How to Run
To compile a Buttercup source file, type:

    ./bcupc.js <buttercup_source_file>

Where `<buttercup_source_file>` is the name of a Buttercup source file. You can
try with these files:

* `prog1.bcup`
* `prog2.bcup`

To execute the resulting WASM file, type:

    ./execute.js <wasm_file>

Where `<wasm_file>` is a WebAssembly binary file, for example:

* `prog1.wasm`
* `prog2.wasm`

## How to Clean

To delete all the files that get created automatically, at the terminal type:

    make clean